 /* serv2.c */
 /* server exa */
 /* make sure you have either defined. my linux is redhat as to this writing */

 #define CYGWIN

 #ifdef CYGWIN
 #include "cygwin/socket.h"
 #include "cygwin/in.h"
 #endif

 #ifdef LINUX
 #include "linux/socket.h"
 #include "linux/in.h"
 #include "linux/time.h"
 #endif

                       /* this is non-checked for now */
 #define INMAX 8*1024
 #define SERV_TCP_PORT 4100
 /*you may want to pick a higher default port number on linux */

 int sockfd,newsockfd,clilen;
 struct sockaddr_in cli_addr, serv_addr;
 char inlin[INMAX];
 struct timeval timeout;
 fd_set fdvar;

 int do_read()
 {
   int rr, n;
   n = INMAX;

   FD_ZERO(&fdvar);
   FD_SET(newsockfd, &fdvar);

   timeout.tv_sec = 0;
   timeout.tv_usec = 0;

   if (select(newsockfd+1,&fdvar,(fd_set *) 0,
      (fd_set *) 0, (struct timeval *) 0) <= 0) return(0);
   if (FD_ISSET(newsockfd,&fdvar)  == 0)
      { return(0); }
   rr = read(newsockfd,inlin,n);
   if (rr <= 0) {
      rr = 0;
   }
   inlin[rr] = '\0';
   return(rr);
 }

 int do_write(b,n)
 char b[];
 int n;
 {
   int rr;
   rr = write(newsockfd,b,n);
   return(rr);
 }

 serv_main()
 {
   if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) <0 ) {
      printf("Error: can't open socket.\n");
      exit(-1);
   }

   bzero( (char *) &serv_addr, sizeof(serv_addr) );
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   serv_addr.sin_port = htons(SERV_TCP_PORT);

   if (bind(sockfd, (struct sockaddr *) &serv_addr,
    sizeof(serv_addr)) < 0) {
      printf("Error: cannot bind socket.\n");
      exit(-1);
   }

   printf("waiting for connection ...\n");
   listen(sockfd,5);

      clilen = sizeof(cli_addr);
      newsockfd = accept(sockfd,
         (struct sockaddr *) &cli_addr, &clilen);
      if (newsockfd < 0) {
         printf("Error opening new socket.\n");
         exit(-1);
      }
   FD_ZERO(&fdvar);
   FD_SET(newsockfd, &fdvar);
   timeout.tv_sec = 0;
   timeout.tv_usec = 0;

   inlin[0] = '\0';
 }
